"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.subscriber = exports.default = void 0;

var _middleware = _interopRequireDefault(require("./middleware"));

var _routes = _interopRequireDefault(require("./routes"));

var _models = _interopRequireWildcard(require("./models"));

var _seed = _interopRequireDefault(require("./models/user/seed"));

var _helpers = require("./helpers");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const ExpressAuthenticator = (db, superUserConfig) => {
  if (!db || !('connection' in db)) throw new Error('MongoDB not connected');
  const api = {};
  api.models = (0, _models.default)(db);
  api.middleware = (0, _middleware.default)(api.models);
  api.routes = (0, _routes.default)(db, api.models, api.middleware);
  api.schema = {
    Access: _models.AccessSchema,
    User: _models.UserSchema
  };
  if (superUserConfig) (0, _seed.default)({
    Model: api.models.User,
    ...superUserConfig
  });
  return api;
};

var _default = ExpressAuthenticator;
exports.default = _default;
const subscriber = _helpers.notify;
exports.subscriber = subscriber;