"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.compareWithHash = exports.createHash = exports.generateRandomSecret = void 0;

var _bcrypt = _interopRequireDefault(require("bcrypt"));

var _crypto = _interopRequireDefault(require("crypto"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const getSalts = () => parseInt(process.env.SALTS || 8, 10);

const generateRandomSecret = (byteSize = 20) => _crypto.default.randomBytes(byteSize).toString('hex');

exports.generateRandomSecret = generateRandomSecret;

const createHash = async str => {
  return _bcrypt.default.hash(str, getSalts());
};

exports.createHash = createHash;

const compareWithHash = (a, b) => {
  return _bcrypt.default.compareSync(a, b);
};

exports.compareWithHash = compareWithHash;