"use strict";

var _mongoose = _interopRequireDefault(require("mongoose"));

var _mongodbMemoryServer = require("mongodb-memory-server");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-next-line
let mongo;
const mongooseOptions = {
  autoIndex: false,
  autoReconnect: false,
  useNewUrlParser: true,
  useUnifiedTopology: true
};

const generateDB = async () => {
  mongo = new _mongodbMemoryServer.MongoMemoryServer();
  return mongo.getConnectionString();
};

beforeAll(async () => {
  global.mongodb = await _mongoose.default.connect((await generateDB()), mongooseOptions);
});
afterAll(async () => {
  await mongo.stop();

  _mongoose.default.connection.close();
});