"use strict";

var _mongoose = require("mongoose");

var _schema = _interopRequireDefault(require("../schema"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Model;
beforeAll(() => {
  Model = (0, _mongoose.model)('test_access', _schema.default);
});
describe('access validation', () => {
  it('should fail without required properties', () => {
    const doc = new Model();
    const {
      errors
    } = doc.validateSync();
    expect(Object.keys(errors)).toEqual(expect.arrayContaining(['op', 'coll']));
  });
  it('should fail without ENUM values', () => {
    const doc = new Model({
      op: 'Insert',
      coll: 'access'
    });
    const {
      errors
    } = doc.validateSync();
    expect(Object.keys(errors)).toEqual(expect.arrayContaining(['op']));
  });
});