"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.preSavePermissionValidation = preSavePermissionValidation;
exports.default = exports.SUPER = void 0;

var _lodash = require("lodash");

var _flat = _interopRequireWildcard(require("flat"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const SUPER = 'Super Developer';
exports.SUPER = SUPER;

async function preSavePermissionValidation() {
  const {
    role,
    op,
    coll
  } = this;
  const doc = await (0, _lodash.invoke)(this, 'constructor.findOne', {
    coll,
    op,
    role
  });

  if (doc) {
    throw new Error('Permission already exists');
  }
}

class AccessDecorator {
  static can(op) {
    return ['Create', 'Update', 'Read', 'Delete'].includes(op) ? async (role, coll) => {
      // should really only be one person like this...
      if (role === SUPER) return {
        fields: '(.*)'
      };
      const resp = await this.findOne({
        role: role || {
          $exists: false
        },
        op,
        coll
      }).select('fields');
      if (!resp) throw new Error('Permission denied');
      return resp;
    } : false;
  }

  $iterateTests(condition) {
    try {
      return (0, _lodash.get)(this, 'fields', '').split(', ').map(v => v.trim()).map(v => new RegExp(v, 'gmi')).some(re => re.test(condition));
    } catch (err) {
      return false;
    }
  }

  pickFrom(obj = {}) {
    const flat = (0, _flat.default)(obj);
    const picked = Object.entries(flat).reduce((acc, [key, value]) => {
      if (this.$iterateTests(key)) acc[key] = value;
      return acc;
    }, {});
    return (0, _flat.unflatten)(picked);
  }

}

exports.default = AccessDecorator;