"use strict";

var _mongoose = require("mongoose");

var _schema = _interopRequireWildcard(require("../schema"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

let UserModel;
beforeAll(() => {
  UserModel = (0, _mongoose.model)('test_users', _schema.default);
});
describe('Email validation', () => {
  it('should return truthy', () => {
    expect(['foo@gmail.com', 'foo+1@gmail.com', 'foo.bar@gmail.com', 'foo@yahoo.ca', 'foo1_92836@gov.uk.en'].every(_schema.isValidEmail)).toBeTruthy();
  });
  it('should return falsy', () => {
    expect(['foo@gmail', 'foo+1@gmail.', 'foo.barmail.com'].every(_schema.isValidEmail)).toBeFalsy();
  });
});
describe('UserModel validation', () => {
  it('should mandate required fields', () => {
    const doc = new UserModel();
    const {
      errors
    } = doc.validateSync();
    expect(Object.keys(errors)).toEqual(expect.arrayContaining(['firstName', 'lastName', 'email', 'secret', 'role']));
  });
  it('should set defaults', () => {
    const doc = new UserModel({
      firstName: 'Jon',
      lastName: 'Doe',
      emai: 'jon.doe@gmail.com',
      secret: 'shh!'
    });
    expect(doc).toMatchObject(expect.objectContaining({
      verified: false,
      frozen: false,
      active: true,
      loginAttempts: 0,
      lang: 'en-CA'
    }));
  });
});