import mongoose from 'mongoose';
import express from 'express';
import bodyParser from 'body-parser';
import authenticator, { subscriber } from '../src';

mongoose.connect(process.env.CONNECTION);

const app = express();
const { middleware, routes } = authenticator(mongoose, {
  firstName: process.env.FIRST_NAME,
  lastName: process.env.LAST_NAME,
  email: process.env.EMAIL,
  password: process.env.PASSSWORD,
});

app.use(
  bodyParser.urlencoded({
    extended: false,
  }),
);

app.use(middleware.init);
app.use(routes);
app.listen(8000);

subscriber.on('password-reset', (e) => {
  // eslint-disable-next-line
  console.log(e);
});
